------------------------------------------------------------
-- Base fns
------------------------------------------------------------

require("guiLib/common")

function UserDataExistsAndIsEqual(obj, key, value)
	return obj:UserDataExists(key) and (obj:GetUserData(key) == value)
end

function UserDataExistsAndIsNotEqual(obj, key, value)
	return obj:UserDataExists(key) and (obj:GetUserData(key) ~= value)
end

------------------------------------------------------------
-- Wait then execute a commande
------------------------------------------------------------

function WaitAndExec(fn, waitTime, safeGroup, userData)
	local screen = GetCurrentScreen()
	if safeGroup ~= nil then
		screen = safeGroup:GetParentScreen()
	end
	
	local event = screen:RegisterTimer(function(evt)
												local safeGroup = evt:GetUserData("safeGroup")
												if safeGroup then
													guiLib_removeAutoDestroyEvent(safeGroup, evt)
												end
												
												evt:GetUserData("fn")(safeGroup, evt:GetInterval(), evt:GetUserData("userData"))
												evt:Destroy()
											end, waitTime, true)
	event:SetUserData("waitTime", waitTime)
	event:SetUserData("safeGroup", safeGroup)
	event:SetUserData("fn", fn)
	event:SetUserData("userData", userData)
	
	if safeGroup ~= nil then
		guiLib_addAutoDestroyEvent(safeGroup, event)
	end
end

------------------------------------------------------------
-- Table
------------------------------------------------------------

function table.isInTable(tbl, value)
	for i, tblVal in pairs(tbl) do
		if value == tblVal then
			return true
		end
	end
	return false
end
