require("guiLib/guiLib")

--------------
-- tmpScreen
tmpScreen = CreateScreen("confirmationScreen", ScreenConfig(screenSize))

-- Ask confirmation
function popupDialog(backScreen, dialogType, message, answerYesFn, answerNoFn, userData)
	local btSize = texMenuBtNormal:GetSize()

	local tmpGroup = tmpScreen:CreateGroup("tmpGroup")
	local width = btSize.x * 2 + 100

	-- Background
	local tmp = tmpGroup:CreateScreenRenderer("gameRenderer")
	tmp:SetTargetScreen(backScreen)
	tmp:SetZpos(-5000)
	
	-- Text
	local tmp = tmpGroup:CreateText("message", message)
	tmp:SetColor(Color(255, 255, 255))
	tmp:SetFont(fontFixedsys)
	tmp:SetSize(40)
	tmp:SetMaxWidth(width)
	local txtSize = tmp:GetTextSize()
	tmp:SetPosition(Vector2D(width / 2 - txtSize.x / 2, 0))
	
	
	-- Bts
	if dialogType == "dialogYesNo" then
		local bt = tmpGroup:CreateGroup("noBt")
		buttonControlCreate(bt, _("No"), btSize)
		buttonSetEventFunction(bt, function(group) myChangeScreen(group:GetUserData("backScreen"), false); group:GetUserData("answerFn")(bt:GetUserData("userData")); group:GetParent():Destroy(); end)
		buttonSetFont(bt, 34, Color(255, 255, 255), fontFixedsys)
		buttonSetImagePack(bt, texMenuBtNormal, texMenuBtOver, texMenuBtPressed)
		buttonSetClickSound(bt, sndBtClick)
		bt:SetPosition(Vector2D(0, txtSize.y + 20))
		bt:SetUserData("answerFn", answerNoFn)
		bt:SetUserData("backScreen", backScreen)
		bt:SetUserData("userData", userData)
		
		local bt = tmpGroup:CreateGroup("yesBt")
		buttonControlCreate(bt, _("Yes"), btSize)
		buttonSetEventFunction(bt, function(group) myChangeScreen(group:GetUserData("backScreen"), false); group:GetUserData("answerFn")(bt:GetUserData("userData")); group:GetParent():Destroy(); end)
		buttonSetFont(bt, 34, Color(255, 255, 255), fontFixedsys)
		buttonSetImagePack(bt, texMenuBtNormal, texMenuBtOver, texMenuBtPressed)
		buttonSetClickSound(bt, sndBtClick)
		bt:SetPosition(Vector2D(width - btSize.x, txtSize.y + 20))
		bt:SetUserData("answerFn", answerYesFn)
		bt:SetUserData("backScreen", backScreen)
		bt:SetUserData("userData", userData)
	elseif dialogType == "dialogOk" then
		local bt = tmpGroup:CreateGroup("okBt")
		buttonControlCreate(bt, _("Ok"), btSize)
		buttonSetEventFunction(bt, function(group) myChangeScreen(group:GetUserData("backScreen"), false); group:GetUserData("answerFn")(bt:GetUserData("userData")); group:GetParent():Destroy(); end)
		buttonSetFont(bt, 34, Color(255, 255, 255), fontFixedsys)
		buttonSetImagePack(bt, texMenuBtNormal, texMenuBtOver, texMenuBtPressed)
		buttonSetClickSound(bt, sndBtClick)
		bt:SetPosition(Vector2D(width / 2 - btSize.x / 2, txtSize.y + 20))
		bt:SetUserData("answerFn", answerYesFn)
		bt:SetUserData("backScreen", backScreen)
		bt:SetUserData("userData", userData)
	elseif dialogType == "dialogAskKey" then
		--[[local bt = tmpGroup:CreateGroup("cancelBt")
		buttonControlCreate(bt, _("Cancel"), btSize)
		buttonSetEventFunction(bt, function(group) myChangeScreen(group:GetUserData("backScreen"), false); group:GetUserData("answerFn")(bt:GetUserData("userData")); group:GetParent():Destroy(); end)
		buttonSetFont(bt, 34, Color(255, 255, 255), fontFixedsys)
		buttonSetImagePack(bt, texMenuBtNormal, texMenuBtOver, texMenuBtPressed)
		buttonSetClickSound(bt, sndBtClick)
		bt:SetPosition(Vector2D(width / 2 - btSize.x / 2, txtSize.y + 20))
		bt:SetUserData("answerFn", answerYesFn)
		bt:SetUserData("backScreen", backScreen)
		bt:SetUserData("userData", userData)]]
		
		-- Key evt
		local event = tmpGroup:GetParentScreen():RegisterButtonEvent(function(keyName, isPressed, event)
																		myChangeScreen(event:GetUserData("backScreen"), false)
																		if keyName == "Escape" then
																			keyName = nil
																		end
																		event:GetUserData("answerFn")(keyName, event:GetUserData("userData"))

																		event:GetUserData("group"):Destroy()
																		soundNs.PlayGlobalSnd(sndBtClick)
																	end, "", true)
		event:SetUserData("backScreen", backScreen)
		event:SetUserData("group", tmpGroup)
		event:SetUserData("userData", userData)
		event:SetUserData("answerFn", answerYesFn)
		guiLib_addAutoDestroyEvent(tmpGroup, event)
	else
		printErrorConsole("Error: dialogType '" .. dialogType .. "' unknown !!")
	end
	
	-- Color rect
	local contentSize = Vector2D(width, txtSize.y)
	if dialogType ~= "dialogAskKey" then
		contentSize.y = contentSize.y + 20 + btSize.y
	end
	local margin = 20
	local tmp = tmpGroup:CreateShapeRectangle("backRect", Vector2D(-margin, -margin), contentSize + Vector2D(margin, margin) * 2, Color(0, 0, 0, 210), 4, Color(157, 135, 13))
	tmp:SetZpos(-100)
	
	tmpGroup:SetPosition(screenSize / 2 - contentSize / 2)
	
	-- Escape event
	local event = tmpGroup:GetParentScreen():RegisterButtonEvent(function(keyName, isPressed, event)
																	myChangeScreen(event:GetUserData("backScreen"), false)
																	event:GetUserData("answerFn")(event:GetUserData("userData"))
																	event:GetUserData("group"):Destroy()
																	soundNs.PlayGlobalSnd(sndBtClick)
																end, "Escape", true)
	if dialogType == "dialogYesNo" then
		event:SetUserData("answerFn", answerNoFn)
	else
		event:SetUserData("answerFn", answerYesFn)
	end
	event:SetUserData("backScreen", backScreen)
	event:SetUserData("group", tmpGroup)
	event:SetUserData("userData", userData)
	guiLib_addAutoDestroyEvent(tmpGroup, event)
	
	-- Change
	myChangeScreen(tmpScreen, false)
end
