require("guiLib/buttonControl")

-- Create screen
inLevelMenuScreen = CreateScreen("inLevelMenuScreen", ScreenConfig(screenSize))

-- Game on background
local tmp = inLevelMenuScreen:CreateScreenRenderer("gameRenderer")
tmp:SetTargetScreen(gameRenderScreen)
tmp:SetZpos(-2000)

-- Blur
local tmp = inLevelMenuScreen:CreatePostFX("blurEffect")
tmp:LoadFromFile(GetCommonDataPath() .. "/blur.sfx")
tmp:SetZpos(-1500)

inLevelMenuMode = "pause"

-- Base
	-- Back
margin = Vector2D(10, 10)
imgNoShadowSize = Vector2D(658, 492)
local tmp = inLevelMenuScreen:CreateSprite("back", inLevelMenuBackTex, (screenSize - imgNoShadowSize) / 2)
tmp:SetZpos(-1000)

inLevelMenuSize = imgNoShadowSize - margin * 2

local tmp = inLevelMenuScreen:CreateGroup("inLevelMenu")
tmp:SetPosition((screenSize - inLevelMenuSize) / 2)

function createInLevelMenu(mode, infoSup)
	local msg = ""
	if mode == "dead" then
		if infoSup == "crash" then
			msg = _("You have received a lethal dose of kinetic energy")
			soundNs.PlayGlobalSnd(sndManDie)
		elseif infoSup == "hurtZone" then
			msg = _("Peaks are dangerous for health")
			soundNs.PlayGlobalSnd(sndManDie)
		elseif infoSup == "bombeWall" then
			msg = _("The goal isn't to make the bombs explode !")
			soundNs.PlayGlobalSnd(sndBombeBurst)
		end
	elseif mode == "win" then
	
		
		-- Save stats
		-- Seulement si on a gagné au moins la medaille de bronze on si on est en mode campagne
		if not isLevelChallenge() or (levelData.stats.minTime <= levelData.baseChallengeTime * bronzeRankRatio) then
			msg = _("Congratulation, you win !") .. "\n\n" .. lvlProgress.getStatsText(levelData.stats, false, isLevelChallenge(), levelData.baseChallengeTime)
		
			lvlProgress.addLevelStats(levelData.name, levelData.stats, isLevelChallenge())
		else
			-- On a perdu malgrè tout
			msg = lvlProgress.getStatsText(levelData.stats, false, isLevelChallenge(), levelData.baseChallengeTime) .. "\n\n" .. _("Bronze medal : ") .. lvlProgress.priv.timeFormat(levelData.baseChallengeTime * bronzeRankRatio)
		end
		
		soundNs.PlayGlobalSnd(sndPlayerWin)
	else
		msg = _("-- Game paused --")
	end

	local parentGrp = inLevelMenuScreen:FindByNameGroup("inLevelMenu")
	inLevelMenuScreen:SetUserData("mode", mode)
	
	-- Reset
	parentGrp:DestroyChildren()
	
	local btMargin = 85
	
	-- Deco
	local infoSize = 124
	if (mode == "win") then
		infoSize = infoSize + btMargin * 2
	end
	
		-- Restart checkpoint
	if (mode == "dead") then
		infoSize = infoSize + btMargin
	end
	
	local tmp = parentGrp:CreateShapeRectangleSize("rect1", Vector2D(20, 20), Vector2D(617, infoSize), Color(0, 0, 0, 200), 0, Color(0, 0, 0))

	local text = parentGrp:CreateText("infoTxt", msg)
	text:SetSize(35)
	text:SetFont(fontFixedsys)
	text:SetMaxWidth(tmp:GetPointPosition(2).x - tmp:GetPointPosition(1).x - 20)
	text:SetPosition(Vector2D(inLevelMenuSize.x / 2 - text:GetTextSize().x / 2, 30))
	
	--[[
	-- Mort:
	Info mort+

	RestartCheckpoint
	Quit to menu

	-- Reussite
	Score+

	Quit to menu

	-- Pause
	Jeu en pause+

	Return to game
	Restart checkpoint
	Quit to menu]]
	
	-- Bts
	local btSize = texMenuBtNormal:GetSize()
	btSize.x = btSize.x * 1.7

	
	
		-- Restart checkpoint
	if (mode == "pause") then
		local bt = parentGrp:CreateGroup("levelBt")
		buttonControlCreate(bt, _("Return"), btSize)
		buttonSetEventFunction(bt, function() myChangeScreen(gameScreen); end)
		buttonSetFont(bt, 34, Color(255, 255, 255), fontFixedsys)
		buttonSetImagePack(bt, texMenuBtNormal, texMenuBtOver, texMenuBtPressed)
		buttonSetClickSound(bt, sndBtClick)
		bt:SetPosition(Vector2D(inLevelMenuSize.x / 2 - btSize.x / 2, 183))
	end
	
		-- Restart checkpoint
	if (mode == "pause") or (mode == "dead") then
		local bt = parentGrp:CreateGroup("levelBt")
		buttonControlCreate(bt, _("Restart the Checkpoint"), btSize)
		buttonSetEventFunction(bt, function()
										if inLevelMenuScreen:GetUserData("mode") == "dead" then -- Pas de confirmation
											restoreCheckpoint()
											myChangeScreen(gameScreen)
										else
											popupDialog(inLevelMenuScreen, "dialogYesNo", _("Do you really want to return to the last Checkpoint ?"),
												function()
													restoreCheckpoint()
													myChangeScreen(gameScreen)
												end,
												
												function()
												
												end)
											end
										end)
		buttonSetFont(bt, 34, Color(255, 255, 255), fontFixedsys)
		buttonSetImagePack(bt, texMenuBtNormal, texMenuBtOver, texMenuBtPressed)
		buttonSetClickSound(bt, sndBtClick)
		bt:SetPosition(Vector2D(inLevelMenuSize.x / 2 - btSize.x / 2, 183 + btMargin))
	end
	
		-- Quit
	local bt = parentGrp:CreateGroup("levelBt")
	buttonControlCreate(bt, _("Return to the map"), btSize)
	buttonSetEventFunction(bt, function()
										if inLevelMenuScreen:GetUserData("mode") == "win" then -- Pas de confirmation
											myChangeScreen(gameRenderScreen, false) -- pour le visuel, on doit utiliser le gameRenderScreen
											myChangeScreen(levelMenuScreen, true, "fade", nil, {onHalfFn = function()
																												destroyLevel()
																												musicNs.loadPlayListMenu() -- Music
																												loadMapObjects() -- Reload map
																											end})
										else
											popupDialog(inLevelMenuScreen, "dialogYesNo", _("Do you really want to go back to the map ?"),
												function()
													myChangeScreen(gameRenderScreen, false) -- pour le visuel, on doit utiliser le gameRenderScreen
													myChangeScreen(levelMenuScreen, true, "fade", nil, {onHalfFn = function()
																														destroyLevel()
																														musicNs.loadPlayListMenu() -- Music
																														loadMapObjects() -- Reload map
																													end})
												end,
												
												function()
												
												end)
										end
									end)
	buttonSetFont(bt, 34, Color(255, 255, 255), fontFixedsys)
	buttonSetImagePack(bt, texMenuBtNormal, texMenuBtOver, texMenuBtPressed)
	bt:SetPosition(Vector2D(inLevelMenuSize.x / 2 - btSize.x / 2, 183 + btMargin * 2))
end



-- Escape event
inLevelMenuScreen:RegisterButtonEvent(function()
									local mode = inLevelMenuScreen:GetUserData("mode")
									
									if (mode == "pause") then
										soundNs.PlayGlobalSnd(sndBtClick)
										myChangeScreen(gameScreen)
									end
								end, "Escape", true)
