------------------------------------------------------------
-- Level 01
------------------------------------------------------------

function initCurrentLevelData()
	levelData = {}
	levelData["back"] = loadTexture("levels/level00.png")
end

function createCurrentLevel(levelGrp)
	-- Back
	local tmp = levelGrp:CreateSprite("backImg")
	tmp:SetImage(levelData["back"])
	tmp:SetZpos(-1000)
	
	-- Particle rain
	local model = ParticleModel(7, 7)
	model:AddRandomParam("alpha", 0.5, 0.3)

	local emitter = ParticleEmitter()
	emitter:MakeLine(Vector2D(0, 0), Vector2D(screenSize.x * 1.3, 0))
	emitter:SetAngles(0, 0)
	emitter:SetDirection(Vector2D(0.25, 1))

	local particleObj = gameRenderScreen:CreateParticleSource("skyBack", model, 710)
	particleObj:SetEmitter(emitter)
	particleObj:SetFlow(100)
	particleObj:SetForce(1000, 1200)
	particleObj.position = Vector2D(screenSize.x / 2, -200)
	particleObj:MakeRenderLines(0.05, 0.1)
	
	-- Décors de base
	createWall(levelGrp, Vector2D(0, 0 ), Vector2D(28, 483 ))
	createWall(levelGrp, Vector2D(0, 0 ), Vector2D(1931, 12 ))
	createWall(levelGrp, Vector2D(1920, 0 ), Vector2D(11, 482 ))
	createWall(levelGrp, Vector2D(0, 454 ), Vector2D(1931, 28 ))
	createWall(levelGrp, Vector2D(28, 219 ), Vector2D(1702, 28 ))	
	
	--Messages
	createMessageZoneMitraille(levelGrp, Vector2D(86, 208), Vector2D(202, 11), {_("Level 0 - The story"), _("Use the keyboard to move to the right")}, 1) -- Utiliser les commandes pour vous déplacer à droite
		
	--Checkpoint Zone
	createCheckpointZone(levelGrp, Vector2D(1730, 247), Vector2D(190, 207))
	
	--Fin de niveau
	createExitZone(levelGrp, Vector2D(53, 324), Vector2D(150, 130)) 
		
	-- Players
	local player1 = initPlayer(1, levelGrp, userCfg.keyConf.player1Keys, Vector2D(76, 218 - playerSize.y))
	playerSetMode(player1, "move")

	local player2 = initPlayer(2, levelGrp, userCfg.keyConf.player2Keys, Vector2D(240, 218 - playerSize.y))
	playerSetMode(player2, "move")
end
