------------------------------------------------------------
-- Level 01
------------------------------------------------------------

function initCurrentLevelData()
	levelData = {}
	levelData["back"] = loadTexture("levels/level01.png")
	
	-- background sky
	levelData["backgroundSky"] = loadTexture("sky_pixels.png")
	levelData["tree"] = loadTexture("objs/tree.png")
end

function createCurrentLevel(levelGrp)
	-- Back
	local tmp = levelGrp:CreateSprite("backImg")
	tmp:SetImage(levelData["back"])
	tmp:SetZpos(-1000)
	
	-- Sky
	setSkyTexture(levelData["backgroundSky"])
	
	-- Fun
	createSimpleImage(levelGrp, levelData["tree"], Vector2D(413, 128), nil, true)

	-- Décors de base
	createWall(levelGrp, Vector2D(7, 8 ), Vector2D(28, 337 ))
	createWall(levelGrp, Vector2D(7, 8 ), Vector2D(850, 28 ))
	createWall(levelGrp, Vector2D(7, 317 ), Vector2D(850, 28 ))
	createWall(levelGrp, Vector2D(829, 8 ), Vector2D(28, 337 ))
	
	--Trois bosses
	createWall(levelGrp, Vector2D(192, 36 ), Vector2D(28, 42 ))
	createWall(levelGrp, Vector2D(407, 36 ), Vector2D(28, 82 ))
	createWall(levelGrp, Vector2D(644, 36 ), Vector2D(28, 150 ))
	
	--Messages
	createMessageZoneMitraille(levelGrp, Vector2D(77, 236), Vector2D(43, 81), {_("Level 1 - Introduction to launches"), _("Think of reading the 'How to play'"), _("Launch the bomb to your teammate using the mouse"), _("Don't let the bombe fall !")}, 1)
	-- Lancer la balle à votre coéquipier avec la souris
	-- Ne faites surtout pas tomber la bombe !
	
	--Fin de niveau
	createExitZone(levelGrp, Vector2D(679, 187), Vector2D(150, 130)) 
		
	-- Players
	local player1 = initPlayer(1, levelGrp, userCfg.keyConf.player1Keys, Vector2D(46, 314 - playerSize.y))
	playerSetMode(player1, "move")

	local player2 = initPlayer(2, levelGrp, userCfg.keyConf.player2Keys, Vector2D(66, 314 - playerSize.y))
	playerSetMode(player2, "throw")
end
