------------------------------------------------------------
-- Level 1
------------------------------------------------------------

function initCurrentLevelData()
	levelData = {}
	levelData["back"] = loadTexture("levels/levelB.png")
	levelData["removable1"] = loadTexture("removablenew.png")
	
	-- background sky
	levelData["backgroundSky"] = loadTexture("sky_pixels.png")
	levelData["tree"] = loadTexture("objs/tree.png")
	levelData["checkpoint"] = loadTexture("objs/checkpoint.png")
	levelData["warning"] = loadTexture("objs/warning.png")
end

function createCurrentLevel(levelGrp)
	-- Back
	local tmp = levelGrp:CreateSprite("backImg")
	tmp:SetImage(levelData["back"])
	tmp:SetZpos(-1000)
	
	-- Sky
	setSkyTexture(levelData["backgroundSky"])

	-- Décor de base
	createWall(levelGrp, Vector2D(-8, 11), Vector2D(45, 1215))
	createWall(levelGrp, Vector2D(7, 1233), Vector2D(2034, 30))
	createWall(levelGrp, Vector2D(7, 13), Vector2D(851, 28))
	createWall(levelGrp, Vector2D(206, 156), Vector2D(651, 27))
	createWall(levelGrp, Vector2D(829, 11), Vector2D(28, 198))
	createWall(levelGrp, Vector2D(603, 326), Vector2D(254, 27))
	createWall(levelGrp, Vector2D(829, 297), Vector2D(28, 84))
	createWall(levelGrp, Vector2D(34, 326), Vector2D(369, 27))
	createWall(levelGrp, Vector2D(34, 666), Vector2D(256, 27))
	createWall(levelGrp, Vector2D(263, 496), Vector2D(594, 27))
	createWall(levelGrp, Vector2D(433, 468), Vector2D(140, 28))
	createWall(levelGrp, Vector2D(433, 439), Vector2D(140, 29))
	createWall(levelGrp, Vector2D(433, 523), Vector2D(27, 199))
	createWall(levelGrp, Vector2D(404, 666), Vector2D(283, 27))
	createWall(levelGrp, Vector2D(829, 468), Vector2D(28, 650))
	createWall(levelGrp, Vector2D(206, 1062), Vector2D(991, 27))
	createWall(levelGrp, Vector2D(688, 1034), Vector2D(141, 28))
	createWall(levelGrp, Vector2D(688, 808), Vector2D(141, 27))
	createWall(levelGrp, Vector2D(857, 893), Vector2D(113, 27))
	createWall(levelGrp, Vector2D(234, 1034), Vector2D(84, 28))
	createWall(levelGrp, Vector2D(206, 836), Vector2D(254, 27))
	createWall(levelGrp, Vector2D(857, 708), Vector2D(227, 42))
	createWall(levelGrp, Vector2D(1056, 750), Vector2D(28, 169))
	createWall(levelGrp, Vector2D(1283, 708), Vector2D(757, 42))
	createWall(levelGrp, Vector2D(2020, 750), Vector2D(20, 511))
	createWall(levelGrp, Vector2D(1737, 893), Vector2D(283, 27))
	createWall(levelGrp, Vector2D(1737, 1063), Vector2D(283, 27))
	createWall(levelGrp, Vector2D(1822, 1090), Vector2D(27, 28))
	createWall(levelGrp, Vector2D(1084, 893), Vector2D(368, 28))
	createWall(levelGrp, Vector2D(1255, 1176), Vector2D(84, 58))
	createWall(levelGrp, Vector2D(1339, 1205), Vector2D(397, 29))
	createWall(levelGrp, Vector2D(1652, 1176), Vector2D(84, 29))
	createWall(levelGrp, Vector2D(34, 921), Vector2D(86, 27))
	createWall(levelGrp, Vector2D(433, 1090), Vector2D(27, 28))

	
	-- Escaliers
	createWall(levelGrp, Vector2D(35, 212), Vector2D(56, 57))
	createWall(levelGrp, Vector2D(35, 269), Vector2D(113, 57))
	createWall(levelGrp, Vector2D(433, 439), Vector2D(140, 57))
	createWall(levelGrp, Vector2D(35, 609), Vector2D(142, 57))
	createWall(levelGrp, Vector2D(319, 779), Vector2D(55, 58))
	createWall(levelGrp, Vector2D(433, 808), Vector2D(27, 29))
	createWall(levelGrp, Vector2D(433, 864), Vector2D(113, 57))
	createWall(levelGrp, Vector2D(433, 921), Vector2D(169, 26))
	createWall(levelGrp, Vector2D(234, 1034), Vector2D(84, 29))
	createWall(levelGrp, Vector2D(35, 1176), Vector2D(113, 57))
	createWall(levelGrp, Vector2D(1452, 949), Vector2D(57, 141))
	createWall(levelGrp, Vector2D(1509, 1006), Vector2D(56, 84))
	createWall(levelGrp, Vector2D(1565, 1063), Vector2D(57, 27))
	createWall(levelGrp, Vector2D(1396, 921), Vector2D(56, 169))
	
	-- Murs laissant passer la bombe
	local ph = createWall(levelGrp, Vector2D(829, 211), Vector2D(28, 86))
	wallEnableBombePass(ph, true)
	
	local ph = createWall(levelGrp, Vector2D(829, 381), Vector2D(28, 87))
	wallEnableBombePass(ph, true)
	
	local ph = createWall(levelGrp, Vector2D(433, 722), Vector2D(27, 86))
	wallEnableBombePass(ph, true)
	
	local ph = createWall(levelGrp, Vector2D(1084, 708), Vector2D(199, 42))
	wallEnableBombePass(ph, true)
	
	-- Checkpoint zone 
	createCheckpointZone(levelGrp, Vector2D(924, 1119), Vector2D(83, 112))
	
	createCheckpointZone(levelGrp, Vector2D(513, 992), Vector2D(63, 71))
	
	createCheckpointZone(levelGrp, Vector2D(75, 501), Vector2D(88, 109))
	
	createCheckpointZone(levelGrp, Vector2D(1152, 786), Vector2D(118, 108))
	
	-- Surfaces amovibles	
	local button = createOnOffButton(levelGrp, Vector2D(784, 986), nil)
    local area1 = createRemovableArea(levelGrp, Vector2D(750, 764), Vector2D(73, 42), levelData["removable1"], Vector2D(0, 0))
    createRemovableAreaButton({area1}, button, false)
    
	local button = createOnOffButton(levelGrp, Vector2D(1960, 974), nil)
    local area1 = createRemovableArea(levelGrp, Vector2D(1662, 882), Vector2D(73, 42), levelData["removable1"], Vector2D(0, 0))
    createRemovableAreaButton({area1}, button, false)
    
	local button = createOnOffButton(levelGrp, Vector2D(1828, 804), nil)
    local area1 = createRemovableArea(levelGrp, Vector2D(976, 1024), Vector2D(73, 42), levelData["removable1"], Vector2D(0, 0))
    createRemovableAreaButton({area1}, button, false)
	
	
	
	-- Portes && Button
	local button = createOnOffButton(levelGrp, Vector2D(515, 587), nil)
	local door = doorCreate(levelGrp, Vector2D(433, 1118), Vector2D(25, 115))
	createDoorButton(door, button, false)
	
	local button = createOnOffButton(levelGrp, Vector2D(895, 806), nil)
	local door = doorCreate(levelGrp, Vector2D(1822, 1118), Vector2D(27, 115))
	createDoorButton(door, button, false)
	
	
	local button = createTimerButton(levelGrp, Vector2D(277, 945), 7, nil)
	local door = doorCreate(levelGrp, Vector2D(433, 947), Vector2D(25, 116))
	createDoorButton(door, button, false)
	
	local button = createTimerButton(levelGrp, Vector2D(703, 1143), 2, nil)
	local door = doorCreate(levelGrp, Vector2D(828, 1118), Vector2D(25, 116))
	createDoorButton(door, button, false)
	
	-- Exit zone
	createExitZone(levelGrp, Vector2D(1867, 1100), Vector2D(150, 130))
	
	-- Message
	createMessageZone(levelGrp, Vector2D(721, 208), Vector2D(95, 118), _("Ohhh ! What a good view !")) -- "Ohhh ! Quelle belle vue !"
	createMessageZone(levelGrp, Vector2D(721, 378), Vector2D(95, 118), _("We can see the neighbors below.")) -- Tiens, on voit chez les voisins en dessous.
	
	-- Fun
	createSimpleImage(levelGrp, levelData["tree"], Vector2D(1318, 520), nil, true)
	createSimpleImage(levelGrp, levelData["tree"], Vector2D(1658, 520), nil, true)
	
	createSimpleImage(levelGrp, levelData["checkpoint"], Vector2D(924, 1119), nil, true)
	createSimpleImage(levelGrp, levelData["checkpoint"], Vector2D(513, 992), nil, true)
	createSimpleImage(levelGrp, levelData["checkpoint"], Vector2D(75, 501), nil, true)
	createSimpleImage(levelGrp, levelData["checkpoint"], Vector2D(1152, 786), nil, true)
	
	createSimpleImage(levelGrp, levelData["warning"], Vector2D(369, 957), nil, true)
	createSimpleImage(levelGrp, levelData["warning"], Vector2D(736, 1128), nil, true)
	
	-- Players
	local player1 = initPlayer(1, levelGrp, userCfg.keyConf.player1Keys, Vector2D(760, 155 - playerSize.y))
	playerSetMode(player1, "move")

	local player2 = initPlayer(2, levelGrp, userCfg.keyConf.player2Keys, Vector2D(690, 155 - playerSize.y))
	playerSetMode(player2, "throw")
end
