------------------------------------------------------------
-- Map 1
------------------------------------------------------------

function initCurrentMapData()	
	-- Back
	mapData["back"] = loadTexture("maps/map1.png")
	
	-- Batiments - Matthieu
	mapData["level00"] = loadTexture("maps/level00.png")
	mapData["level01"] = loadTexture("maps/level01.png")
	mapData["level02"] = loadTexture("maps/level02.png")
	mapData["level03"] = loadTexture("maps/level03.png")
	mapData["level04"] = loadTexture("maps/level04.png")
	mapData["level05"] = loadTexture("maps/level05.png")
	mapData["level06"] = loadTexture("maps/level06.png")
	
	-- Batiments - Nicolas
	mapData["levelA"] = loadTexture("maps/levelA.png")
	mapData["levelB"] = loadTexture("maps/levelB.png")
	mapData["levelC"] = loadTexture("maps/levelC.png")
end

function createCurrentMap(mapGrp)
	-- Deco
	local tmp = mapGrp:CreateSprite("back", mapData["back"], Vector2D(0, 0))
	tmp:SetZpos(-1000)
	
	-- Matthieu
	createLevelBt(mapGrp,
					{Vector2D(173, 608), Vector2D(178, 628), Vector2D(312, 642), Vector2D(354, 594), Vector2D(492, 575), Vector2D(488, 566), Vector2D(328, 454), Vector2D(261, 498), Vector2D(172, 609)},
					Vector2D(171, 455),
					mapData["level00"],
					"level00.lua",
					_("Level 0 - The story"),
					{},
					23)
	
	createLevelBt(mapGrp,
					{Vector2D(962, 338), Vector2D(1008, 332), Vector2D(1038, 361), Vector2D(1035, 387), Vector2D(990, 393), Vector2D(962, 363)},
					Vector2D(961, 332),
					mapData["level01"],
					"level01.lua",
					_("Level 1 - Introduction to launches"),
					{"level00.lua"},
					8)
					
	createLevelBt(mapGrp,
					{Vector2D(1096, 514), Vector2D(1093, 542), Vector2D(1098, 578), Vector2D(1179, 586), Vector2D(1187, 558), Vector2D(1179, 521)},
					Vector2D(1093, 513),
					mapData["level02"],
					"level02.lua",
					_("Level 2 - Introduction to the buttons, timers"), --"Initiation au bouton, minuteur et surfaces amovibles",
					{"level01.lua"},
					20)
					
	createLevelBt(mapGrp,
					{Vector2D(516, 336), Vector2D(518, 375), Vector2D(525, 431), Vector2D(584, 425), Vector2D(580, 369), Vector2D(575, 331)},
					Vector2D(515, 330),
					mapData["level03"],
					"level03.lua",
					_("Level 3 - Introduction to the permeable surfaces and the peaks"), -- Initiation aux surfaces perméables et piques
					{"level02.lua"},
					50)
					
	createLevelBt(mapGrp,
					{Vector2D(396, 155),
					Vector2D(370, 173), Vector2D(383, 239), Vector2D(411, 232), Vector2D(415, 243), Vector2D(459, 246), Vector2D(483, 228), Vector2D(477, 182), Vector2D(427, 180), Vector2D(425, 157)},
					Vector2D(370, 155),
					mapData["level04"],
					"level04.lua",
					_("Level 4 - Introduction to the bouncing surfaces"), --Initiation aux surfaces rebondissantes
					{"levelA.lua"},
					120)
					
	createLevelBt(mapGrp,
					{Vector2D(619, 173), Vector2D(608, 184), Vector2D(611, 229), Vector2D(691, 231), Vector2D(699, 217), Vector2D(698, 200), Vector2D(682, 200), Vector2D(682, 173)},
					Vector2D(607, 172),
					mapData["level05"],
					"level05.lua",
					_("Level 5 - Dealing with permeable surfaces"), -- Surfaces perméables
					{"levelA.lua"},
					45)
					
	createLevelBt(mapGrp,
					{Vector2D(1275, 427), Vector2D(1336, 431), Vector2D(1341, 411), Vector2D(1336, 401), Vector2D(1345, 366), Vector2D(1325, 327), Vector2D(1267, 324), Vector2D(1257, 376)},
					Vector2D(1255, 324),
					mapData["level06"],
					"level06.lua",
					_("Level 6 - A look of deja vu"), -- Un petit air de déjà vu
					{"level04.lua", "levelB.lua"},
					85)
					
	-- Nicolas
	createLevelBt(mapGrp,
					{Vector2D(182, 360), Vector2D(171, 318), Vector2D(231, 300), Vector2D(300, 346), Vector2D(311, 388), Vector2D(250, 409)},
					Vector2D(170, 299),
					mapData["levelA"],
					"levelA.lua",
					_("Level A - Beware of falling"), -- Attention aux chutes
					{"level03.lua"},
					105)
					
	createLevelBt(mapGrp,
					{Vector2D(838, 450), Vector2D(874, 454), Vector2D(875, 490), Vector2D(934, 496), Vector2D(934, 525), Vector2D(928, 560), Vector2D(826, 548)},
					Vector2D(826, 449),
					mapData["levelB"],
					"levelB.lua",
					_("Level B - We change the format"), -- On change de format
					{"level05.lua"},
					205)
					
	createLevelBt(mapGrp,
					{Vector2D(1207, 74), Vector2D(1274, 73), Vector2D(1280, 44), Vector2D(1426, 76), Vector2D(1500, 146), Vector2D(1474, 248), Vector2D(1207, 234), Vector2D(1191, 194)},
					Vector2D(1187, 43),
					mapData["levelC"],
					"levelC.lua",
					_("Level C - Be careful, you could lose"), -- Faites attention, vous pourriez vous y perdre
					{"level06.lua"},
					300)
end
