require("guiLib/guiLib")

-- Ns
keyMenuNs = keyMenuNs or {}
keyMenuNs.optionTbl = {}

-- Create screen
keyMenuNs.screen = CreateScreen("levelMenuScreen", ScreenConfig(screenSize))
keyMenuNs.screen:RegisterButtonEvent(function() myChangeScreen(menuOptionNs.screen, true, "slide2"); end, "Escape", true)

-- Back
local tmp = keyMenuNs.screen:CreateSprite("back", mainMenuBackTex, Vector2D(0, 0))
tmp:SetZpos(-1000)

------------------------------------------------------------
-- Create the option window
------------------------------------------------------------

btSize = texMenuBtNormal:GetSize()
btMargin = 15

-- Size
inSize = Vector2D(1480, 500)

controlHeight = btSize.y * 0.8
fontSize = 28
keyMenuNs.body = keyMenuNs.screen:CreateGroup("optionsWin")
keyMenuNs.body:SetPosition(Vector2D(60, 0))

local btSize = texMenuBtNormal:GetSize()
local keyBtSize = texMenuBtNormal:GetSize() * 0.65

-- Add key



------------------------------------------------------------
-- Load / Save
------------------------------------------------------------
function keyMenuNs.setOptionFromTbl(tbl)	
	for i = 1, #keyMenuNs.optionTbl do	
		local subTbl = tbl
		for id, key in pairs(keyMenuNs.optionTbl[i].keyList) do
			subTbl = subTbl[key]
		end
			
		if keyMenuNs.optionTbl[i].optionType == "key" then
			keyChoiceCtrl.setKey(keyMenuNs.optionTbl[i].grp, subTbl)
		elseif keyMenuNs.optionTbl[i].optionType == "yesNo" then
			if subTbl == true then
				choiceControlChangeId(keyMenuNs.optionTbl[i].grp, 1)
			else
				choiceControlChangeId(keyMenuNs.optionTbl[i].grp, 2)
			end
		elseif keyMenuNs.optionTbl[i].optionType == "percent" then
			choiceControlChangeId(keyMenuNs.optionTbl[i].grp, math.floor(subTbl / 10) + 1)
		end
	end
end

function keyMenuNs.saveOptionToTbl()
	local tbl = {}
	for i = 1, #keyMenuNs.optionTbl do
		local currentOption = keyMenuNs.optionTbl[i]
	
		local subTbl = tbl
		for j = 1, (#currentOption.keyList - 1) do
			if type(subTbl[currentOption.keyList[j]]) ~= "table" then
				subTbl[currentOption.keyList[j]] = {}
			end
			subTbl = subTbl[currentOption.keyList[j]]
		end
	
		if keyMenuNs.optionTbl[i].optionType == "key" then
			subTbl[currentOption.keyList[#currentOption.keyList]] = keyChoiceCtrl.getKey(keyMenuNs.optionTbl[i].grp)
		elseif keyMenuNs.optionTbl[i].optionType == "yesNo" then
			subTbl[currentOption.keyList[#currentOption.keyList]] = (choiceControlGetCurrentId(keyMenuNs.optionTbl[i].grp) == 1)
		elseif keyMenuNs.optionTbl[i].optionType == "percent" then
			subTbl[currentOption.keyList[#currentOption.keyList]] = (choiceControlGetCurrentId(keyMenuNs.optionTbl[i].grp) - 1) * 10
		end
	end
	
	return tbl;
end

function keyMenuNs.addKeyOption(label, yPos, keyList)
	-- Ctrl
	local grp = keyChoiceCtrl.create(keyMenuNs.body, Vector2D(inSize.x - keyBtSize.x, yPos), keyBtSize, label)
	
	-- Label
	local label = keyMenuNs.body:CreateText("label", label)
	label:SetSize(fontSize)
	label:SetFont(fontFixedsys)
	label:SetPosition(Vector2D(0, yPos + controlHeight / 2 - label:GetTextSize().y / 2))
	
	-- yPos
	yPos = yPos + keyBtSize.y + 7
	
	-- Add tbl
	table.insert(keyMenuNs.optionTbl, {optionType = "key", grp = grp, keyList = keyList})
	
	-- yPos
	return yPos
end

function keyMenuNs.addYesNoOption(label, yPos, keyList)
	-- Ctrl
	local controlWidth = keyBtSize.x
	
	local grp = keyMenuNs.body:CreateGroup("choiceYesNoCtrl")
	choiceControlCreate(grp, controlWidth, 28, fontFixedsys)
	choiceControlAddStringTbl(grp, {_("Yes"), _("No")})
	grp:SetPosition(Vector2D(inSize.x - controlWidth, yPos))
	
	-- Label
	local label = keyMenuNs.body:CreateText("label", label)
	label:SetSize(fontSize)
	label:SetFont(fontFixedsys)
	label:SetPosition(Vector2D(0, yPos + controlHeight / 2 - label:GetTextSize().y / 2))
	
	-- yPos
	yPos = yPos + keyBtSize.y + 7
	
	-- Add tbl
	table.insert(keyMenuNs.optionTbl, {optionType = "yesNo", grp = grp, keyList = keyList})
	
	-- yPos
	return yPos
end

function keyMenuNs.addTitle(label, yPos)
	yPos = yPos + 5 -- Margin top
	
	local tmp = keyMenuNs.body:CreateText("titleText", label, 30, Color(255, 255, 255), Vector2D(0, 0))
	tmp:SetMaxWidth(screenSize.x / 2)
	tmp:SetFont(fontFixedsys)
	tmp:SetUnderligned(true)
	
	local txtSize = tmp:GetTextSize()
	tmp:SetPosition(Vector2D((screenSize.x - txtSize.x) / 2, yPos))
	
	yPos = yPos + txtSize.y + 2 -- Margin bottom
	
	return yPos
end

	-- Fullscreen
local yPos = 0

yPos = keyMenuNs.addTitle(_("Player 1 keys"), yPos)
yPos = keyMenuNs.addKeyOption(_("Right"), yPos, {"player1Keys", "keyRight"})
yPos = keyMenuNs.addKeyOption(_("Left"), yPos, {"player1Keys", "keyLeft"})
yPos = keyMenuNs.addKeyOption(_("Jump / Top"), yPos, {"player1Keys", "keyJump"})
yPos = keyMenuNs.addKeyOption(_("Action / Down"), yPos, {"player1Keys", "keyAction"})

yPos = keyMenuNs.addTitle(_("Player 2 keys"), yPos)
yPos = keyMenuNs.addKeyOption(_("Right"), yPos, {"player2Keys", "keyRight"})
yPos = keyMenuNs.addKeyOption(_("Left"), yPos, {"player2Keys", "keyLeft"})
yPos = keyMenuNs.addKeyOption(_("Jump / Top"), yPos, {"player2Keys", "keyJump"})
yPos = keyMenuNs.addKeyOption(_("Action / Down"), yPos, {"player2Keys", "keyAction"})

yPos = keyMenuNs.addTitle(_("Fake mouse keys"), yPos)
yPos = keyMenuNs.addYesNoOption("Enable aiming with keyboard", yPos, {"isFakeMouse"})
yPos = keyMenuNs.addKeyOption(_("Move Right"), yPos, {"fakeMouseKeys", "keyRight"})
yPos = keyMenuNs.addKeyOption(_("Move Left"), yPos, {"fakeMouseKeys", "keyLeft"})
yPos = keyMenuNs.addKeyOption(_("Move Top"), yPos, {"fakeMouseKeys", "keyUp"})
yPos = keyMenuNs.addKeyOption(_("Move Down"), yPos, {"fakeMouseKeys", "keyDown"})
yPos = keyMenuNs.addKeyOption(_("Launch"), yPos, {"fakeMouseKeys", "keyLaunch"})

keyMenuNs.setOptionFromTbl(userCfg.keyConf)

------------------------------------------------------------
-- Buttons
------------------------------------------------------------

-- Bts events
function keyMenuNs.onDefault()
	keyMenuNs.setOptionFromTbl(userCfg.GetDefaultKeyConf())
end

function keyMenuNs.onCancel()
	keyMenuNs.setOptionFromTbl(userCfg.keyConf)
end

function keyMenuNs.onApply()	
	userCfg.keyConf = userCfg.AddUnsetInTable(keyMenuNs.saveOptionToTbl(), userCfg.GetDefaultKeyConf())
	userCfg.SaveAllConf()
end

-- Buttons
local bt = keyMenuNs.screen:CreateGroup("btDefault")
buttonControlCreate(bt, _("Default"), btSize)
buttonSetEventFunction(bt, keyMenuNs.onDefault)
buttonSetFont(bt, 34, Color(255, 255, 255), fontFixedsys)
buttonSetImagePack(bt, texMenuBtNormal, texMenuBtOver, texMenuBtPressed)
buttonSetClickSound(bt, sndBtClick)
bt:SetPosition(screenSize - Vector2D(btSize.x * 4 + btMargin * 4, btSize.y + btMargin))

local bt = keyMenuNs.screen:CreateGroup("btCancel")
buttonControlCreate(bt, _("Cancel"), btSize)
buttonSetEventFunction(bt, keyMenuNs.onCancel)
buttonSetFont(bt, 34, Color(255, 255, 255), fontFixedsys)
buttonSetImagePack(bt, texMenuBtNormal, texMenuBtOver, texMenuBtPressed)
buttonSetClickSound(bt, sndBtClick)
bt:SetPosition(screenSize - Vector2D(btSize.x * 3 + btMargin * 3, btSize.y + btMargin))

local bt = keyMenuNs.screen:CreateGroup("btApply")
buttonControlCreate(bt, _("Apply"), btSize)
buttonSetEventFunction(bt, keyMenuNs.onApply)
buttonSetFont(bt, 34, Color(255, 255, 255), fontFixedsys)
buttonSetImagePack(bt, texMenuBtNormal, texMenuBtOver, texMenuBtPressed)
buttonSetClickSound(bt, sndBtClick)
bt:SetPosition(screenSize - Vector2D(btSize.x * 2 + btMargin * 2, btSize.y + btMargin))


local bt = keyMenuNs.screen:CreateGroup("btReturn")
buttonControlCreate(bt, _("Return"), btSize)
buttonSetEventFunction(bt, function() myChangeScreen(menuOptionNs.screen, true, "slide2"); end)
buttonSetFont(bt, 34, Color(255, 255, 255), fontFixedsys)
buttonSetImagePack(bt, texMenuBtNormal, texMenuBtOver, texMenuBtPressed)
bt:SetPosition(screenSize - Vector2D(btSize.x + btMargin, btSize.y + btMargin))

